<template>
    <div class="container">
        <div class="filter">
            <select name="tags"
                    id="tagSelector"
                    v-model="filterValue">
                <option value="">All</option>
                <option v-for="tag in uniqueTextTags"
                        :value="tag.text"
                        :key="tag.id">{{tag.text}}</option>
            </select>
<!--            <input type="text"-->
<!--                   placeholder="Filter" >-->
        </div>
        <div class="tableContainer">
            <div class="tableHeader">
                <div class="column">Sub-Image</div>
                <div class="column">Tag</div>
                <div class="column">Linked Image</div>
                <div class="column sm-hidden">X position</div>
                <div class="column sm-hidden">Y position</div>
                <div class="column md-hidden">X Scale</div>
                <div class="column md-hidden">Y Scale</div>
                <div class="column md-hidden">Radius</div>
            </div>
            <transition-group name="slide">
                <div class="tableElement"
                     v-for="image in filteredSubImages"
                     :key="image.imageURL">
                    <div class="imageContainer">
                        <img :src="image.imageURL" alt="">
                    </div>
                    <div class="column">{{textTag(image)}}</div>
                    <div class="column">{{linkedImage(image)}}</div>
                    <div class="column sm-hidden">{{xPosition(image)}}</div>
                    <div class="column sm-hidden">{{yPosition(image)}}</div>
                    <div class="column md-hidden">{{xScale(image)}}</div>
                    <div class="column md-hidden">{{yScale(image)}}</div>
                    <div class="column md-hidden">{{radius(image)}}</div>
                </div>
            </transition-group>
        </div>
    </div>
</template>

<script>
    export default {
      name: 'DrawList',
      props: {
        circles: {
          type: Array
        },
        textTags: {
          type: Array
        },
        subImages: {
          type: Array
        }
      },
      data() {
        return {
            filterValue: ''
          }
      },
      watch: {
        textTags: function(newVal) {
          console.log(newVal);
        }
      },
      computed: {
        filteredTexts() {
          return this.filterValue.length > 0
            ? this.textTags.filter(item => item.text.startsWith(this.filterValue))
            : this.textTags;
        },
        filteredCircles() {
          const ids = this.filteredTexts.map(item => item.id).map(item => item.split('-')[1]);
          return this.filterValue.length > 0
            ? this.circles.filter(item => ids.includes(item.id))
            : this.circles;
        },
        filteredSubImages() {
          const ids = this.filteredTexts.map(item => item.id).map(item => item.split('-')[1]);
          return this.filterValue.length > 0
            ? this.subImages.filter(item => ids.includes(item.id))
            : this.subImages;
        },
        uniqueTextTags() {
          const uniqueTextArray = [];
          this.textTags.map(item => item.text).filter((x, i, a) => a.indexOf(x) === i).forEach(item => uniqueTextArray.push({id: Date.now()+this.getRandomInt(1000000), text: item}));
          return uniqueTextArray;
        },
      },
      methods: {
        xPosition(image) {
          return this.filteredCircles.find(item => item.id === image.id).x.toFixed(2);
        },
        yPosition(image) {
          return this.filteredCircles.find(item => item.id === image.id).y.toFixed(2);
        },
        xScale(image) {
          return this.filteredCircles.find(item => item.id === image.id).scaleX.toFixed(2);
        },
        yScale(image) {
          return this.filteredCircles.find(item => item.id === image.id).scaleY.toFixed(2);
        },
        radius(image) {
          return this.filteredCircles.find(item => item.id === image.id).radius.toFixed(2);
        },
        linkedImage(image) {
          return this.filteredCircles.find(item => item.id === image.id).linkedImage;
        },
        textTag(image) {
          return this.filteredTexts.find(item => item.id === '-'+image.id).text;
        },
        getRandomInt(max) {
            return Math.floor(Math.random() * Math.floor(max));
        }
      }
    }

</script>

<style scoped>
    .tableHeader, .tableElement {
        display: flex;
        flex-flow: row;
        justify-content: space-around;
        align-items: center;
    }
    .tableHeader {
        font-weight: bold;
        margin-bottom: 20px;
    }
    .tableElement {
        margin-bottom: 20px;
        transition: all 0.5s ease-out;
    }
    .column, .imageContainer {
        min-width: 130px;
        max-width: 130px;
        width: 130px;
    }
    .imageContainer {
        display: flex;
        flex-flow: row;
        justify-content: center;
    }
    img {
        width: 100px;
        height: 100px;
    }
    input[type=text] {
        border: none;
        background-color: unset;
        border-bottom: 2px solid goldenrod;
        margin-right: 40px;
    }
    .filter {
        display: flex;
        flex-flow: row;
        justify-content: flex-end;
        margin-top: 20px;
        margin-bottom: 30px;
    }
    select{
        border: none;
        background-color: unset;
        border-bottom: 2px solid goldenrod;
        margin-right: 40px;
    }
    .tableContainer {
        max-height: 450px;
        overflow-y: auto;
        overflow-x: hidden;
    }

    @media (max-width: 1024px) {
        .md-hidden {
            display: none;
        }
    }

    @media (max-width: 768px) {
        .sm-hidden {
            display: none;
        }
    }
    .slide-enter{
        opacity: 0;
    }
    .slide-enter-active {
        animation: slide-in 1s ease-out forwards;
        transition: opacity .5s;
    }
    .slide-leave {
        position: absolute
    }
    .slide-leave-active {
        animation: slide-out 1s ease-out forwards;
        transition: opacity 1s;
        opacity: 0;
        position: absolute;
    }
    .slide-move {
        transition: transform 1s;
    }

    @keyframes slide-in {
        from {
            transform: translateY(20px);
        }
        to {
            transform: translateY(0);
        }
    }

    @keyframes slide-out {
        from {
            transform: translateY(0);
        }
        to {
            transform: translateY(-20px);
        }
    }
</style>